/* 
**Implementacin del algoritmo quick-sort para la ordenacin de structs 
*/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define ELEMENTOS 4
#define MAX 20

typedef struct {
  char nombre[MAX];
  char apellido[MAX];        
} t_agenda;

/* Prototipo de la funcin de comparar */
int comparar(const void *arg1, const void *arg2)
{
t_agenda *t_arg1, *t_arg2;
int cmp_apell, cmp_nom;
  t_arg1 = (t_agenda *) arg1; 
  t_arg2 = (t_agenda *) arg2; 
  cmp_apell = strcmp(t_arg1->apellido, t_arg2->apellido);
  cmp_nom = strcmp(t_arg1->nombre, t_arg2->nombre);

  if (cmp_apell < 0) return -1;
  else if (cmp_apell > 0) return 1;
  else /* cmp_apell == 0 */
    if (cmp_nom < 0) return -1;
    else if (cmp_nom > 0) return 1;
    else return 0; /* cmp_nom == 0 */
}

int main()
{
   int i, num;
   t_agenda lista[ELEMENTOS];

   for(i = 0; i < ELEMENTOS; i++) {
     printf("Introduzca nombre (%d): ", i+1);
     scanf("%s", lista[i].nombre);
     printf("Introduzca apellido (%d): ", i+1);
     scanf("%s", lista[i].apellido);
   }      

   /* Quick-Sort */
   qsort(lista, ELEMENTOS, sizeof(t_agenda), comparar);

    /* Mostramos la lista ordenada */
   for(i = 0; i < ELEMENTOS; i++) printf("%s %s ", lista[i].nombre, lista[i].apellido);
   printf("\n");
   
   return 0;
}
